#include <ansi_c.h>
#include <windows.h>
#include <stdio.h>

#include "Lb_CUDA.h"

#include "LB_def.h"
#include "LB_aux.h"
#include "analysis.h"

#include "menup.h"
			
int MENU_Handle;  
int iRun = 1;

int main (int argc, char *argv[])
{
	const int _ARRAY_SIZE = 1024;
	
	int	iEvent;
	int	iHandle, iCtrl;
	
	int *a, *b, *c;
	void *g_a = NULL, *g_b = NULL, *g_c = NULL;
	
	/////////////////////////////////////////////////////
	//CPU
	/////////////////////////////////////////////////////
	a = (int *) malloc(sizeof(int) * _ARRAY_SIZE);
	b = (int *) malloc(sizeof(int) * _ARRAY_SIZE);
	c = (int *) malloc(sizeof(int) * _ARRAY_SIZE);
	
	for(int i = 0; i < _ARRAY_SIZE; i++)
	{
		a[i] = i;
		b[i] = i;		
	}
	
	ULONGLONG t = GetTickCount64();
	for(int i = 0; i < _ARRAY_SIZE; i++)
	{
		c[i] = a[i] + b[i];
	}
	printf("Perf: %I64u", (GetTickCount64() - t));
	
	free(a);
	free(b);
	free(c);
	
	CUDA_SetDevice(1);
	
	/////////////////////////////////////////////////////
	//GPU
	////////////////////////////////////////////////////
/*	CUDA_Malloc(g_a, sizeof(int) * _ARRAY_SIZE);
	CUDA_Malloc(g_b, sizeof(int) * _ARRAY_SIZE);
	CUDA_Malloc(g_c, sizeof(int) * _ARRAY_SIZE);
	
	CUDA_MemcpyToDevice(g_a, a, sizeof(int) * _ARRAY_SIZE); 
	CUDA_MemcpyToDevice(g_b, b, sizeof(int) * _ARRAY_SIZE); 
	CUDA_MemcpyToDevice(g_c, c, sizeof(int) * _ARRAY_SIZE); 
	
	t = GetTickCount64();
	CUDA_Add(g_c, g_a, g_b, _ARRAY_SIZE);
	CUDA_ThreadSynchronize();
	printf("Perf: %I64u", (GetTickCount64() - t));
	
	CUDA_FreeMemory(g_a);
	CUDA_FreeMemory(g_b);
	CUDA_FreeMemory(g_c);
	
	*/
	
	
	
	
	
	
	
	
	
	//Load panel
	MENU_Handle = LoadPanel(0, "UIR\\menup.uir", PANEL);
	DisplayPanel(MENU_Handle);
	while(iRun)
	{
		iEvent = GetUserEvent(0, &iHandle, &iCtrl);
			
		switch(iCtrl)
		{

			default:
				break;
		}
	}
	DiscardPanel(MENU_Handle);
}


int CVICALLBACK QuitPanel (int panel, int event, void *callbackData,
													 int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_CLOSE:
			iRun = 0;
			break;
	}
	return 0;
}